diff --git a/Documentation/kernel-parameters.txt b/Documentation/kernel-parameters.txt
index 5ae8608..c1cbb4c 100644
--- a/Documentation/kernel-parameters.txt
+++ b/Documentation/kernel-parameters.txt
@@ -2631,6 +2631,10 @@ bytes respectively. Such letter suffixes can also be entirely omitted.
 		pcie_scan_all	Scan all possible PCIe devices.  Otherwise we
 				only look for one device below a PCIe downstream
 				port.
+		driver		Provide an override to the devid<->driver mapping
+				for a specific slot.
+				Bind PCI slot 0001:02:03.4 to pci-stub by:
+					driver[0001:02:03.4]=pci-stub
 
 	pcie_aspm=	[PCIE] Forcibly enable or disable PCIe Active State Power
 			Management.
diff --git a/drivers/pci/bus.c b/drivers/pci/bus.c
index 73aef51..b49f5cc 100644
--- a/drivers/pci/bus.c
+++ b/drivers/pci/bus.c
@@ -15,6 +15,8 @@
 #include <linux/proc_fs.h>
 #include <linux/slab.h>
 
+#include <asm/setup.h>
+
 #include "pci.h"
 
 void pci_add_resource_offset(struct list_head *resources, struct resource *res,
@@ -230,6 +232,114 @@ EXPORT_SYMBOL(pci_bus_alloc_resource);
 
 void __weak pcibios_resource_survey_bus(struct pci_bus *bus) { }
 
+struct driver_override_entry {
+	u16 domain;
+	u8 bus;
+	u8 devfn;
+	char *driver_name;
+	struct list_head list;
+};
+
+static LIST_HEAD(driver_override_entries);
+
+static int pci_device_parse_driver_override(char *param, char *val,
+					    const char *unused)
+{
+	unsigned int domain, bus, dev, fn;
+	char  *buf;
+	struct driver_override_entry *entry;
+	int ret;
+
+	buf = kmalloc(COMMAND_LINE_SIZE, GFP_KERNEL);
+	if (!buf)
+		goto err_buf;
+
+	while (val) {
+		char *k = strchr(val, ',');
+
+		if (k)
+			*k++ = 0;
+
+		if (strncmp(val, "driver", 6)) {
+			val = k;
+			continue;
+		}
+
+		memset(buf, 0, COMMAND_LINE_SIZE);
+		ret = sscanf(val + 6, "[%4x:%2x:%2x.%2x]=%s",
+			     &domain, &bus, &dev, &fn, buf);
+		if (ret != 5) {
+			pr_warn("PCI: Invalid command line: %s\n", val);
+			val = k;
+			continue;
+		}
+
+		entry = kzalloc(sizeof(*entry), GFP_KERNEL);
+		if (!entry)
+			goto err_entry;
+
+		INIT_LIST_HEAD(&entry->list);
+		entry->domain = domain;
+		entry->bus = bus;
+		entry->devfn = PCI_DEVFN(dev, fn);
+		entry->driver_name = kstrdup(buf, GFP_KERNEL);
+		if (!entry->driver_name)
+			goto err_driver_name;
+
+		list_add_tail(&entry->list, &driver_override_entries);
+		val = k;
+	}
+
+	kfree(buf);
+	return 0;
+
+err_driver_name:
+	kfree(entry);
+
+err_entry:
+	kfree(buf);
+
+err_buf:
+	pr_err("PCI: Out of memory while parsing command line: %s\n", val);
+	return -ENOMEM;
+}
+
+static void pci_device_setup_driver_override(struct pci_dev *dev)
+{
+	static int parse_done;
+	struct driver_override_entry *entry;
+
+	if (!parse_done) {
+		char *cmdline = kstrdup(saved_command_line, GFP_KERNEL);
+
+		if (!cmdline)
+			goto err_out_of_mem;
+
+		parse_args("pci", cmdline, NULL,
+			   0, 0, 0, &pci_device_parse_driver_override);
+		kfree(cmdline);
+		parse_done = 1;
+	}
+
+	list_for_each_entry(entry, &driver_override_entries, list) {
+		if (pci_domain_nr(dev->bus) != entry->domain ||
+		    dev->bus->number != entry->bus ||
+		    dev->devfn != entry->devfn)
+			continue;
+
+		dev->driver_override = kstrdup(entry->driver_name, GFP_KERNEL);
+		if (!dev->driver_override)
+			goto err_out_of_mem;
+
+		break;
+	}
+
+	return;
+
+err_out_of_mem:
+	pr_err("PCI: Out of memory while setting up driver override\n");
+}
+
 /**
  * pci_bus_add_device - start driver for a single device
  * @dev: device to add
@@ -245,6 +355,7 @@ void pci_bus_add_device(struct pci_dev *dev)
 	 * are not assigned yet for some devices.
 	 */
 	pci_fixup_device(pci_fixup_final, dev);
+	pci_device_setup_driver_override(dev);
 	pci_create_sysfs_dev_files(dev);
 	pci_proc_attach_device(dev);
 
diff --git a/drivers/pci/pci.c b/drivers/pci/pci.c
index 625a4ac..37809d4 100644
--- a/drivers/pci/pci.c
+++ b/drivers/pci/pci.c
@@ -4508,6 +4508,8 @@ static int __init pci_setup(char *str)
 				pcie_bus_config = PCIE_BUS_PEER2PEER;
 			} else if (!strncmp(str, "pcie_scan_all", 13)) {
 				pci_add_flags(PCI_SCAN_ALL_PCIE_DEVS);
+			} else if (!strncmp(str, "driver", 6)) {
+				/* lazy evaluation by the pci subsystem */
 			} else {
 				printk(KERN_ERR "PCI: Unknown option `%s'\n",
 						str);